/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/*
 * Copyright (C) 2016 HUBzero Foundation, LLC
 *
 * Author: Leif Delgass <ldelgass@purdue.edu>
 */

#include "Icons.h"

using namespace GeoVis;

std::tr1::unordered_map<std::string, std::string> GeoVis::g_icons;

void GeoVis::initIconMap()
{
    g_icons["pin"] = ICON_PIN;
    g_icons["pin1"] = ICON_PIN1;
    g_icons["pin2"] = ICON_PIN2;
    g_icons["pin3"] = ICON_PIN3;
    g_icons["pin4"] = ICON_PIN4;
    g_icons["pin5"] = ICON_PIN5;
    g_icons["pin6"] = ICON_PIN6;
    g_icons["pin7"] = ICON_PIN7;
    g_icons["pin8"] = ICON_PIN8;
    g_icons["pin9"] = ICON_PIN9;
    g_icons["pin10"] = ICON_PIN10;
}

std::string GeoVis::getIconFile(const char *name)
{
    IconHashmap::iterator itr = g_icons.find(name);
    if (itr == g_icons.end()) {
        return "";
    } else {
        return itr->second;
    }
}
