/* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
/*
 * Copyright (C) 2015  HUBzero Foundation, LLC
 *
 * Author: Leif Delgass <ldelgass@purdue.edu>
 */
#ifndef GEOVIS_PICKER_H
#define GEOVIS_PICKER_H

#include <osgEarth/Picker>
#include <osgEarth/ObjectIndex>

namespace GeoVis {

class Renderer;

struct HoverCallback : public osgEarth::Picker::Callback {
public:
    HoverCallback(Renderer *renderer);

    void onHit(osgEarth::ObjectID id);
    void onMiss();
    bool accept(const osgGA::GUIEventAdapter& ea, const osgGA::GUIActionAdapter& aa);

private:
    Renderer *_renderer;
};

struct SelectCallback : public osgEarth::Picker::Callback {
public:
    SelectCallback(Renderer *renderer);

    void onHit(osgEarth::ObjectID id);
    void onMiss();
    bool accept(const osgGA::GUIEventAdapter& ea, const osgGA::GUIActionAdapter& aa);

private:
    Renderer *_renderer;
    float _x, _y;
    bool _modifier;
    osgEarth::GeoPoint _pickPoint;
};

struct DeleteCallback : public osgEarth::Picker::Callback {
public:
    DeleteCallback(Renderer *renderer) :
        _renderer(renderer)
    {}

    void onHit(osgEarth::ObjectID id);

private:
    Renderer *_renderer;
};

extern void setHighlightByObjectID(osgEarth::ObjectID id);
extern void clearHighlight();

}

#endif
