#include <vector>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <fstream>

#include <osgDB/FileNameUtils>

#include "IData.h"

using namespace IData;

int main(int argc, char *argv[])
{
    iDataInit(getenv("USER"));

    std::vector<Collection> collections;
    getCollectionList(collections);
    std::cout << std::endl << std::endl;
    for (std::vector<Collection>::iterator itr = collections.begin();
         itr != collections.end(); ++itr) {
        std::cout << "id: " << itr->id << " name: " << itr->name << std::endl;
    }

    int collection = 3;
    if (argc > 1) {
        collection = atoi(argv[1]); 
    }

    std::cout << std::endl << std::endl;
    std::vector<DirectoryItem> dir;
    getContents(collection, "", dir);
    std::cout << std::endl << std::endl;
    for (std::vector<DirectoryItem>::iterator itr = dir.begin();
         itr != dir.end(); ++itr) {
        std::cout << " name: " << itr->name;
        if (!itr->isDir) {
            std::cout << " size: " << itr->size << " ctime: " << itr->ctime
                      << " type: " << itr->type << " doi: " << itr->doi;
        }
        std::cout << std::endl;
    }

    std::cout << std::endl << std::endl;
    const char *filename = NULL;
    if (argc > 2) {
        filename = argv[2];
    } else if (collection == 3) {
        filename = "station.csv";
    } else {
        iDataCleanup();
        return 0;
    }

    std::ostringstream oss;
    oss << "//" << filename;
    Buffer buff;
    getFile(collection, oss.str().c_str(), &buff);
    std::cout << std::endl << std::endl;
    std::cout << filename << " size: " << buff.size << std::endl;
    std::ofstream file(filename);
    file.write((char *)buff.data, buff.size);
    file.close();

    iDataCleanup();
    return 0;
}
